def getTail(fnname):
    pos = fnname.rfind('::')
    if pos >= 0:
        return fnname[pos+2:]
    else:
        return fnname

def buildfunclist(combined_oplists):
    funclist = []
    funcdict = dict()
    nfile = len(combined_oplists)
    for fileind in range(nfile):
        opcount = len(combined_oplists[fileind])
        curfunc = []
        nestlev = 0
        nestlevseek = -1
        for opind in range(opcount):
            item = combined_oplists[fileind][opind]
            if item[0] == '$FUNC':
                if len(curfunc) > 0:
                    print curfunc
                    print item
                    print fileind
                    print opind
                    assert False
                curfunc = [fileind,opind]
                curfunc.extend(item)
                shortname = getTail(item[1])
                if shortname in funcdict:
                    print shortname
                    print funcdict[shortname]
                    print fileind,opind
                    assert False
                funcdict[shortname] = [fileind,opind,len(funclist)]
                nestlevseek = nestlev
                global_list = []
                call_list = []
                return_list = []
            elif item[0] == '$ROOT':
                curfunc = [fileind,opind,item[0], '', []]
                nestlevseek = nestlev
            elif item[0] == '$CALL':
                call_list.append([fileind,opind])
            elif item[0] == '$RETURN':
                return_list.append([fileind,opind])
            elif item[0] == '{':
                nestlev += 1
            elif item[0] == '}':
                nestlev -= 1
                assert nestlev >= 0
                if nestlev == nestlevseek:
                    nestlevseek = -1
                    curfunc.append(global_list)
                    curfunc.append(call_list)
                    curfunc.append(return_list)
                    funclist.append(curfunc)
                    if len(funclist) == 46 or len(funclist) == 47:
                        print "funclist[45] =",funclist[45]
                    curfunc = []
            elif item[0] == '$GLOBAL' or item[0] == '$GLOBALU':
                global_list.append([fileind,opind])
    return funclist,funcdict
